﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace NuclearSubmarine
{
    /// <summary>
    /// Interaction logic for MainUserControl.xaml
    /// </summary>
    public partial class MainUserControl : UserControl
    {
        public MainWindow owner = null;

        public MainUserControl()
        {
            InitializeComponent();
            initialize_game();
            show_room();
            szActionDescription = string.Empty;
            textBox1.Focus();
        }

        protected override void OnRender(DrawingContext drawingContext)
        {
            base.OnRender(drawingContext);
            DrawContents(drawingContext);
        }

        string szRoomDescription;
        string szActionDescription;
        void trim_action_text()
        {
	        while (szActionDescription.Length > 2048)
	        {
                int index = szActionDescription.IndexOf ('\n');
		        if (index == -1)
			        return;
                szActionDescription = szActionDescription.Substring (index + 1);
	        }
        }

        void initialize_game()
        {
            p = new place[]
            {
	            new place ("", 0, 0, 0, 0, 0, 0 ),
	            new place ("You are in a nuclear submarine", 0, 0, 2, 19, 0, 0),
                new place ("You are in an airlock chamber", 0, 0, 0, 1, 0, 0),
                new place ("You are in an underwater area", 0,0,0,2,0,4),
                new place ("You are in an underwater area", 0,0,0,0,3,5),
                new place ("You are in an underwater area", 0,0,0,25,4,0),
                new place ("You are in the score room", 0, 0, 0,0,1,0),
                new place ("You are in the room of illumination", 0, 26, 0,0,0,0),
                new place ("You are in the first dark room", 26, 12, 10, 9, 0, 0),
                new place ("You are in an enchanted room", 0, 0, 8, 0, 0, 0),
                new place ("You are in a big room in the cave", 0, 0, 0, 8, 0, 0),
                new place ("You are in the room of valuable weaponry", 0, 0, 13, 0, 0, 10),
                new place ("You are at the edge of a cliff", 8, 0,0,0,0,0),
                new place ("You are in the room of \"spring\"", 0, 0, 0, 11, 0, 0),
                new place ("You are at the bottom of a cliff", 0, 0,15,17,0,0),
                new place ("You are in a room called \"Tehran\"", 0, 0,0,14,0,0),
                new place ("You are in a secret room", 0, 0, 0, 15, 0, 0),
                new place ("You are at the foot of a rusted gateway", 0, 0, 14, 0, 0, 0),
                new place ("You are in a treasure room", 0,17,0,0,0,0),
                new place ("You are in the submarine's engine room", 0,0,1,0,0,0),
                new place ("You are in a twisty cave", 21, 22, 21, 23, 0, 0),
                new place ("You are in a twisty cave", 23, 22, 20, 20, 0, 0),
                new place ("You are in a twisty cave", 20, 23, 21, 23, 0, 0),
                new place ("You are in a twisty cave", 20, 22, 21, 22, 24, 0),
                new place ("You are in a dead end", 0, 0, 0, 0, 0, 23),
                new place ("You are in an underwater treasure room", 0, 0, 5, 0, 0, 0),
                new place ("You are in the first air room", 0, 0, 0, 0, 0, 5)
            };

            ob = new adventure_object[]
            {
	            new adventure_object ("", 0),
	            new adventure_object ("Closed hatch on the floor", 1),
	            new adventure_object ("Start button", 19),
	            new adventure_object ("Empty reactor", 19),
	            new adventure_object ("Reactor loaded with plutonium", 0),
	            new adventure_object ("SCUBA outfit", 6),
	            new adventure_object ("Loaded spear gun", 6),
	            new adventure_object ("Empty spear gun", 0),
	            new adventure_object ("=Person-eating shark=", 4),  // it's non-sexist, you see
	            new adventure_object ("Cave", 5),
	            new adventure_object ("Wall mirror", 26),
	            new adventure_object ("Lit lamp", 7),
	            new adventure_object ("Curtain of darkness", 26),
	            new adventure_object ("* Simulated diamond necklace *", 8),
	            new adventure_object ("Blaster wand", 9),
	            new adventure_object ("Cave in on the ceiling", 10),
	            new adventure_object ("* Plastic dagger *", 11),
	            new adventure_object ("Trampoline", 13),
	            new adventure_object ("Small shut oyster", 14),
	            new adventure_object ("* Cultured pearl *", 0),
	            new adventure_object ("* Iranian rug *", 15),   // "Persian" is just SO 19th century
	            new adventure_object ("Copper key", 2),
	            new adventure_object ("Can of None-In-1 Oil", 16),
	            new adventure_object ("Rusted northbound gate", 17),
	            new adventure_object ("* Collection of counterfeit coins *", 18),
	            new adventure_object ("Curtain of light", 18),
	            new adventure_object ("Piece of radioactive plutonium", 22),
	            new adventure_object ("Set of lead tongs", 24),
	            new adventure_object ("* Imitation treasure chest *", 25),
	            new adventure_object ("Red button", 2)
            };

            cp = 1;
            wearingSCUBA = false;
            oiledGate = false;
        }

        void show_room()
        {
            if (cp > 7  &&  cp < 25  &&  cp != 19  &&  ob[11].room != cp  &&  ob[11].room != 27)
            {
                szRoomDescription = "It's too dark to see!";
                return;
            }

	        string [] dir = new string[]
	        {
		        "North", "South", "East", "West", "Up", "Down"
	        };

	        szRoomDescription = p[cp].name + ".";
	        bool foundOne = false;
            int charColumn = 0;
            for (int i = 1; i < ob.Length; ++i)
		        if (ob[i].room == cp)
		        {
			        if (!foundOne)
			        {
				        szRoomDescription += "  Visible items:\n\n";
                        foundOne = true;
			        }
                    if (ob[i].name.Length + charColumn > 77)
                    {
                        szRoomDescription += "\n";
                        charColumn = 0;
                    }
                    szRoomDescription += ob[i].name + ".  ";
                    charColumn += ob[i].name.Length + 3;
                };
	        foundOne = false;
	        for (int i = 0; i <= 5; ++i)
		        if (p[cp].exit[i] != 0)
		        {
			        if (!foundOne)
			        {
				        szRoomDescription += "\n\nObvious exits:";
				        foundOne = true;
			        }
			        szRoomDescription += " " + dir[i];
		        }
        }

        void DrawContents(DrawingContext dc)
        {
            Point upperLeftCornerOfTextBox = textBox1.TranslatePoint(new Point(0, 0), this);

            FormattedText ft = new FormattedText(szActionDescription,
                System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                new Typeface("Verdana"), 12, System.Windows.Media.Brushes.Black);
            dc.DrawText (ft, new Point(5, upperLeftCornerOfTextBox.Y - ft.Height - 5));

            ft = new FormattedText(szRoomDescription,
                System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                new Typeface("Verdana"), 12, Brushes.Black);
            dc.DrawRectangle (Brushes.White, null, new Rect (0, 0, 2000, ft.Height + 12));
            dc.DrawText(ft, new Point(5, 5));
            dc.DrawLine (new Pen (Brushes.Black, 1), new Point (0, ft.Height + 10),
                         new Point (2000, ft.Height + 10));
            
            if (textBox1.Visibility == System.Windows.Visibility.Visible)
            {
                ft = new FormattedText ("  ------> What now? ",
                    System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                    new Typeface("Verdana"), 12, System.Windows.Media.Brushes.Black);
                dc.DrawText (ft, new Point (5, upperLeftCornerOfTextBox.Y + 4));
            }
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                // The user pressed enter.  Process the command.
                string szCommand = textBox1.Text;
                int verb;
				NounType noun;
                if (input_command (szCommand, out verb, out noun))
                    do_command(verb, noun);

                textBox1.Text = string.Empty;
				trim_action_text();
                InvalidateVisual();
            }
        }


        struct place
        {
	        public string name;
	        public int [] exit;    // 6 exits, one for each direction
            public place (string theName, int north, int south, int east, int west, int up, int down)
            {
                exit = new int[6];
                name = theName;
                exit[0] = north;
                exit[1] = south;
                exit[2] = east;
                exit[3] = west;
                exit[4] = up;
                exit[5] = down;
            }
        };
        place[] p;

        struct adventure_object
        {
	        public string name;
	        public int room;    // if room == 27, it's in your inventory
            public adventure_object (string theName, int startingRoom)
            {
                name = theName;
                room = startingRoom;
            }
        };
        adventure_object[] ob;

        int cp; // the Current Place in the adventure
        bool wearingSCUBA;
        bool oiledGate;
        
        string verb_str, noun_str;
        enum NounType
        {
            none,
            HATC,
            BUTT,
            REAC,
            OUTF, SCUB,
            SPEA, GUN,
            SHAR,
            CAVE,
            MIRR,   // 10
            LAMP,
            DARK,
            NECK,
            WAND,
            DAGG,   // 15
            TRAM,
            OYST,
            PEAR,
            RUG, CARP,   // 20
            KEY,
            OIL,
            GATE,
            COIN,
            LIGH,   // 25
            PLUT,
            TONG,
            TREA, CHES,
            last
        }

        private bool input_command (string szCommand, out int verb, out NounType noun)
        {
	        string [] verb_table = new string[]
	        {
		        "",
		        "NORT", "N", "SOUT", "S", "EAST", "E", "WEST", "W", "UP", "U", "DOWN", "D",
		        "GET", "TAKE",
		        "DROP", "RELE",
                "THRO",
                "PRES", "PUSH",
		        "OPEN", "UNLO",
		        "JUMP",
		        "GO",
		        "SHOO",
                "KILL",
                "WAVE",
                "INSE",
                "WEAR",
		        "SEAR",
		        "OIL",
		        "LOOK",
		        "INVE", "I",
		        "HELP",
		        "QUIT",
		        "SWIM",
                "SCOR",
                "BREA",
                ".",
                "P",
                "L",
                "SAVE",
                "LOAD"
	        };
	        string [] noun_table = new string[]
	        {
		        "",
                "HATC",
                "BUTT",
                "REAC",
                "OUTF", "SCUB",
                "SPEA", "GUN",
                "SHAR",
                "CAVE",
                "MIRR",
                "LAMP",
                "DARK",
                "NECK",
                "WAND",
                "DAGG",
                "TRAM",
                "OYST",
                "PEAR",
                "RUG", "CARP",
                "KEY",
                "OIL",
                "GATE",
                "COIN",
                "LIGH",
                "PLUT",
                "TONG",
                "TREA", "CHES"
	        };
            verb = 0;
            noun = NounType.none;

	        verb_str = string.Empty;
	        noun_str = string.Empty;

	        szActionDescription += "  ------> What now? " + szCommand + "\n";
	        int i = 0;
	        while (i < szCommand.Length  &&  szCommand[i] != ' ')
		        ++i;
	        verb_str = szCommand.Substring (0, i);
	        if (i < 30)
	        {
		        int j = i;
		        while (j < szCommand.Length  &&  szCommand[j] == ' ')
			        ++ j;
		        if (j < szCommand.Length)
			        noun_str = szCommand.Substring (j);
	        }
            string verbStrToCompare = verb_str;
            if (verbStrToCompare.Length > 4)
                verbStrToCompare = verbStrToCompare.Substring (0,4);
            verbStrToCompare = verbStrToCompare.ToUpper();
            i = 1;
            while (i < verb_table.Length && verbStrToCompare != verb_table[i])
		        ++i;
            if (i < verb_table.Length)
		        verb = i;
	        else
	        {
		        szActionDescription += "I don't know how to \"" + verb_str + "\" something.\n";
		        return false;
	        }
	        if (noun_str != string.Empty)
	        {
                string nounStrToCompare = noun_str;
                if (nounStrToCompare.Length > 4)
                    nounStrToCompare = nounStrToCompare.Substring(0, 4);
                nounStrToCompare = nounStrToCompare.ToUpper();
                NounType n = NounType.none;
                ++n;
                while (n < NounType.last && nounStrToCompare != noun_table[(int)n])
                    ++n;
                if (n < NounType.last)
                    noun = n;
                else
                {
                    szActionDescription += "I don't know what \"" + noun_str + "\" is.\n";
                    return false;
                }
            }
            return true;
        }

        // Master verb function chooser, derived from BASIC on-goto statement.
        private void do_command(int verb, NounType noun)
        {
            switch (verb)
            {
                case 1:
                case 2:
                    move_dir(0);
                    break;
                case 3:
                case 4:
                    move_dir(1);
                    break;
                case 5:
                case 6:
                    move_dir(2);
                    break;
                case 7:
                case 8:
                    move_dir(3);
                    break;
                case 9:
                case 10:
                    move_dir(4);
                    break;
                case 11:
                case 12:
                    move_dir(5);
                    break;
                case 13:
                case 14:
                    verb_take(noun);
                    break;
                case 15:
                case 16:
                    verb_drop(noun);
                    break;
                case 17:
                    verb_throw(noun);
                    break;
                case 18:
                case 19:
                    verb_press(noun);
                    break;
                case 20:
                case 21:
                    verb_open(noun);
                    break;
                case 22:
                    verb_jump();
                    break;
                case 23:
                    verb_go(noun);
                    break;
                case 24:
                    verb_shoot();
                    break;
                case 25:
                    verb_kill();
                    break;
                case 26:
                    verb_wave(noun);
                    break;
                case 27:
                    verb_insert(noun);
                    break;
                case 28:
                    verb_wear(noun);
                    break;
                case 29:
                    verb_search();
                    break;
                case 30:
                    verb_oil(noun);
                    break;
                case 31:
                    verb_look(noun);
                    break;
                case 32:
                case 33:
                    verb_inventory();
                    break;
                case 34:
                    verb_help();
                    break;
                case 35:
                    verb_quit();
                    break;
                case 36:
                    verb_swim();
                    break;
                case 37:
                    verb_score();
                    break;
                case 38:
                    verb_break(noun);
                    break;
                case 39:
                    verb_take(noun);
                    break;
                case 40:
                    verb_drop (noun);
                    break;
                case 41:
                    verb_look (noun);
                    break;
                case 42:
                    verb_save();
                    break;
                case 43:
                    verb_load();
                    break;
            }
            show_room();
        }

        private void drown()
        {
            szActionDescription += "You can't breathe ";
            if (cp == 2 &&  p[cp].exit[3] == 0  ||  cp == 3  ||  cp == 4  ||  cp == 5  ||  cp == 25)
                szActionDescription += "sea ";
            szActionDescription += "water!  You're dead!\n";
            lose();
        }

        private void move_dir(int direc)
        {
	        if (p[cp].exit[direc] == 0)
		        szActionDescription += "There is no way to go that direction.\n";
            else if (ob[8].room == cp  &&  direc == 5)
                szActionDescription += "The shark will not let you pass!!!\n";
            else if (p[cp].exit[direc] == 5  &&  !wearingSCUBA)
                drown();
            else
	        {
    		    cp = p[cp].exit[direc];
		        szActionDescription += "Ok\n";
	        }
        }

        private void verb_what()
        {
            szActionDescription += verb_str + " what?\n";
        }

        private int MapNounToObject (NounType noun, int room)
        {
            switch (noun)
            {
                case NounType.HATC:
                    return 1;
                case NounType.BUTT:
                    if (ob[2].room == room)
                        return 2;
                    else
                        return 29;
                case NounType.REAC:
                    if (ob[3].room == room)
                        return 3;
                    else
                        return 4;
                case NounType.OUTF:
                case NounType.SCUB:
                    return 5;
                case NounType.SPEA:
                case NounType.GUN:
                    if (ob[6].room == room)
                        return 6;
                    else
                        return 7;
                case NounType.SHAR:
                    return 8;
                case NounType.CAVE:
                    if (ob[15].room == room)
                        return 15;
                    else
                        return 9;
                case NounType.MIRR:
                    return 10;
                case NounType.LAMP:
                    return 11;
                case NounType.DARK:
                    return 12;
                case NounType.NECK:
                    return 13;
                case NounType.WAND:
                    return 14;
                case NounType.DAGG:
                    return 16;
                case NounType.TRAM:
                    return 17;
                case NounType.OYST:
                    return 18;
                case NounType.PEAR:
                    return 19;
                case NounType.RUG:
                case NounType.CARP:
                    return 20;
                case NounType.KEY:
                    return 21;
                case NounType.OIL:
                    return 22;
                case NounType.GATE:
                    return 23;
                case NounType.COIN:
                    return 24;
                case NounType.LIGH:
                    return 25;
                case NounType.PLUT:
                    return 26;
                case NounType.TONG:
                    return 27;
                case NounType.TREA:
                case NounType.CHES:
                    return 28;
            }
            return 0;
        }

        private void verb_take (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.HATC  ||
                     noun == NounType.BUTT  ||
                     noun == NounType.REAC  ||
                     noun == NounType.SHAR  ||
                     noun == NounType.CAVE  ||
                     noun == NounType.MIRR  ||
                     noun == NounType.DARK  ||
                     noun == NounType.OYST  ||
                     noun == NounType.GATE  ||
                     noun == NounType.LIGH)
                szActionDescription += "It's beyond your power to do that.\n";
            else
            {
                int numItemsCarried = 0;
                for (int i = 1; i <= 28; ++i)
                    if (ob[i].room == 27)
                        ++ numItemsCarried;
                if (numItemsCarried > 6)
                    szActionDescription += "You are currently holding too much. Try: INVENTORY\n";
                else
                {
                    int o = MapNounToObject (noun, cp);
                    if (ob[o].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "Ok\n";
                        ob[o].room = 27;
                        if (o == 26  &&  ob[27].room != 27)
                        {
                            szActionDescription += "The radiation killed you!  You're dead!\n";
                            lose();
                        }
                    }
                }
            }
        }

        private void verb_inventory()
        {
            szActionDescription += "You are currently holding the following:\n";
            bool foundOne = false;
            int charColumn = 0;
            for (int i = 0; i < ob.Length; ++i)
                if (ob[i].room == 27)
                {
                    foundOne = true;
                    if (ob[i].name.Length + charColumn > 77)
                    {
                        szActionDescription += "\n";
                        charColumn = 0;
                    }
                    szActionDescription += ob[i].name + ".  ";
                    charColumn += ob[i].name.Length + 3;
                }
            if (!foundOne)
                szActionDescription += "Nothing at all";
            szActionDescription += "\n";
            if (wearingSCUBA)
                szActionDescription += "(You're wearing the " + ob[5].name + ")\n";
        }

        private void verb_drop (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else
            {
                int o = MapNounToObject(noun, 27);
                if (ob[o].room != 27)
                    szActionDescription += "You aren't carrying it!\n";
                else
                {
                    szActionDescription += "Ok\n";
                    ob[o].room = cp;
                    if (o == 5  &&  wearingSCUBA) // can't wear it if you're not holding it
                    {
                        wearingSCUBA = false;
                        if (cp == 2 &&  p[cp].exit[3] == 0  ||  cp == 3  ||  cp == 4  ||  cp == 5  ||  cp == 25)
                            drown();
                    }
                }
            }
        }

        private void verb_look (NounType noun)
        {
            szActionDescription += "You see nothing special.\n";
        }

        private void verb_open (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.OYST)
                if (ob[18].room != cp)
                    szActionDescription += "You don't see it here.\n";
                else if (ob[16].room != 27)
                    szActionDescription += "You need something to open the small "
                        + noun_str + " with.\n";
                else if (ob[19].room != 0)
                    szActionDescription += "It's empty.\n";
                else
                {
                    szActionDescription +=
                        "The oyster opens up, a pearl rolls to the west, and the oyster promptly snaps\n" +
                        "shut again.\n";
                    ob[19].room = 17;
                }
            else if (noun != NounType.HATC  &&  noun != NounType.GATE)
                szActionDescription += "Sorry, no keyhole in a " + noun_str + "!\n";
            else if (ob[21].room != 27)
                szActionDescription += "You don't have a key!\n";
            else if (noun == NounType.HATC)
                if (ob[1].room != cp)
                    szActionDescription += "You don't see it here.\n";
                else
                {
                    szActionDescription += "The downward hatch is now open.\n";
                    ob[1].room = 0;
                    p[cp].exit[5] = 6;
                }
            else if (ob[23].room != cp)
                szActionDescription += "You don't see it here.\n";
            else if (!oiledGate)
                szActionDescription += "Sorry, the door seems to be rusted shut.\n";
            else
            {
                szActionDescription += "The gateway to the north is now " + verb_str + "ed.\n";
                ob[23].room = 0;
                p[cp].exit[0] = 18;
            }
        }

        private void verb_jump()
        {
            if (cp == 14  &&  ob[17].room == cp)
            {
                szActionDescription += "Boiiiing!\n";
                cp = 12;
            }
            else if (cp != 12)
                szActionDescription += "Ok.  Isn't this fun???!?\n";
            else
            {
                szActionDescription += "Aaaaahhhhh!\n";
                if (ob[17].room != 14)
                {
                    szActionDescription += "You're smashed to bits from the fall!  You're dead!\n";
                    lose();
                }
                else
                {
                    szActionDescription += "You fall through the air, and land safely on the trampoline.\n";
                    cp = 14;
                }
            }
        }

        private void verb_wear (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.OUTF  &&  noun != NounType.SCUB)
                szActionDescription += "You can't wear a " + noun_str + "!\n";
            else if (ob[5].room != 27)
                szActionDescription += "You aren't carrying it!\n";
            else if (wearingSCUBA)
                szActionDescription += "You're already wearing it.\n";
            else
            {
                szActionDescription += "Ok\n";
                wearingSCUBA = true;
            }
        }

        private void verb_wave (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.WAND)
                szActionDescription += "You can't wave a " + noun_str + "!\n";
            else if (ob[14].room != 27)
                szActionDescription += "You don't have a " + noun_str + ".\n";
            else if (ob[15].room != cp)
                szActionDescription += "Ok.  Isn't this exciting???!?\n";
            else
            {
                szActionDescription += "BAAAAAAAAM!\nThe blaster wand disintegrated the cave-in!\n";
                ob[15].room = 0;
                p[cp].exit[4] = 11;
            }
        }

        private void verb_insert (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.PLUT)
                szActionDescription += "Sorry, a  " + noun_str + " is not " + verb_str + "able.\n";
            // And no, there is no noun for what you're thinking here.  Perv.
            else if (ob[26].room != 27)
                szActionDescription += "You don't see it here.\n";
            else if (ob[3].room != cp)
                szActionDescription += "There's no place to insert it!\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[3].room = 0;
                ob[4].room = cp;
                ob[26].room = 0;    // not in the original Level II BASIC source, but makes sense
            }
        }

        private void verb_go (NounType noun)
        {
            switch (noun)
            {
                case NounType.none:
                    szActionDescription += "Go where?\n";
                    break;
                case NounType.CAVE:
                    if (ob[9].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "The cave seems to be air pressurized....\n";
                        cp = 26;
                    }
                    break;
                case NounType.DARK:
                    if (ob[12].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else if (ob[11].room != 27)
                        szActionDescription += "You can't get through the impenetrable darkness ... yet!\n";
                    else
                        cp = 8;
                    break;
                case NounType.LIGH:
                    if (ob[25].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else if (cp == 20)
                    {
                        cp = 18;
                        ob[25].room = 18;
                    }
                    else
                    {
                        cp = 20;
                        ob[25].room = 20;
                    }
                    break;
                default:
                    szActionDescription += "You can't go to a " + noun_str + "!!!\n";
                    break;
            }
        }

        private void verb_oil (NounType noun)
        {
            if (ob[22].room != 27)
                szActionDescription += "You don't have any oil.\n";
            else if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.GATE)
                szActionDescription += "You can't oil a " + noun_str + "!\n";
            else if (ob[23].room != cp)
                szActionDescription += "You don't see it here.\n";
            else
            {
                szActionDescription += "Ok.  The gate is now slippery.\n";
                oiledGate = true;
            }
        }

        private void verb_kill()
        {
            szActionDescription += "Be more specific as to how.\n";
        }

        private void verb_throw (NounType noun)
        {
            if (noun != NounType.TRAM  ||  ob[17].room != 27  ||  cp != 12)
                verb_drop (noun);
            else
            {
                szActionDescription += "The " + ob[17].name +
                    " goes over the cliff's edge, and is below you.\n";
                ob[17].room = 14;
            }
        }

        private void verb_search()
        {
            if (cp != 15  ||  p[cp].exit[2] != 0)
                szActionDescription += "You find nothing special.\n";
            else
            {
                szActionDescription += "You found a passage going east.\n";
                p[cp].exit[2] = 16;
            }
        }

        private void verb_shoot()
        {
            if (ob[6].room != 27)
                szActionDescription += "You have nothing to shoot!\n";
            else
            {
                ob[6].room = 0;
                ob[7].room = 27;
                if (ob[8].room != cp)
                    szActionDescription += "Shoom!\n";
                else
                {
                    szActionDescription += "Direct hit!  The shark is gone and dead!\n";
                    ob[8].room = 0;
                }
            }
        }

        private void verb_swim()
        {
            if (cp == 1  ||  cp > 5  &&  cp != 25  ||  cp == 2  &&  p[cp].exit[3] == 1)
                szActionDescription += "I think swimming is best performed in water.\n";
            else
                szActionDescription += "You already are swimming!\n";
        }

        private void verb_score()
        {
            show_score();
            szActionDescription += "but haven't won the game ... yet.\n";
        }

        private void verb_press (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.BUTT)
                szActionDescription += "Sorry, a " + noun_str + " is unpressable.\n";
            else if (ob[29].room == cp)
            {
                szActionDescription += "Whoosh!\n";
                if (p[cp].exit[3] == 1)
                {
                    p[cp].exit[3] = 0;
                    p[cp].exit[2] = 3;
                    if (!wearingSCUBA)
                        drown();
                }
                else
                {
                    p[cp].exit[3] = 1;
                    p[cp].exit[2] = 0;
                }
            }
            else if (ob[2].room != cp)
                szActionDescription += "You don't see it here.\n";
            else if (ob[4].room != 19)
                szActionDescription += "Nothing happened.  Strange....\n";
            else
            {
                szActionDescription += "The submarine amazingly starts, and leaves!\n";
                show_score();
                szActionDescription += "and HAVE won this game!!\n";
                adventure_over();
            }
        }

        private void verb_help()
        {
            if (p[15].exit[2] == 0)
                szActionDescription += "I know how to search for secret passages.\n";
            else if (ob[10].room == cp)
                szActionDescription += "Careful, you wouldn't want 7 years' bad luck....\n";
            else
                szActionDescription += "I know the verb INSERT.  Don't get any funny ideas.\n";
        }

        private void verb_break (NounType noun)
        {
            // Unfortunately, one of the cute puns in the old BASIC versions can't be done here.
            // In BASIC, a STOP command would result in the words "BREAK AT <line number>" appearing
            // at the cursor position, followed by a standard BASIC command prompt.  If the user
            // entered the BREAK verb in the game with no noun following it, we'd execute a STOP.
            // But that joke doesn't carry over very well to a standalone WPF .NET application.
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.MIRR)
                szActionDescription += "Sorry, you can't break a " + noun_str + ".\n";
            else if (ob[10].room != cp)
                szActionDescription += "You don't see it here.\n";
            else
            {
                WithWhatPrompt dlg = new WithWhatPrompt();
                dlg.ShowDialog();
                if (dlg.Response.ToUpper() != "GUN"  &&
                    (dlg.Response.Length < 4  ||  dlg.Response.ToUpper().Substring(0,4) != "SPEA"))
                        szActionDescription += "Sorry, it didn't work.\n";
                else if (ob[7].room != 27)
                    szActionDescription += "You aren't carrying it!\n";
                else
                {
                    szActionDescription +=
                        "Crash!  The mirror is gone, and there's a new hole in the wall of the cave.\n";
                    ob[10].room = 0;
                    p[cp].exit[0] = 7;
                }
            }
        }

        internal void verb_save()
        {
            if (textBox1.Visibility != System.Windows.Visibility.Visible)
            {
                // The adventure ended.  Don't save the game.
                return;
            }
            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.DefaultExt = ".sav";
            dlg.Filter = "Save files (.sav)|*.sav";
            bool? result = dlg.ShowDialog();
            if (result != null  &&  result == true)
            {
                string filename = dlg.FileName;
                StreamWriter f;
                try
                {
                    f = new StreamWriter(filename);
                }
                catch (Exception ex)
                {
                    szActionDescription += "Error creating file \"" + filename + "\":\n" + ex.Message + "\n";
                    return;
                }

                for (int i = 0; i < ob.Length; ++i)
                    f.WriteLine(ob[i].room);
                f.WriteLine(p[2].exit[3]);
                f.WriteLine(p[2].exit[2]);
                f.WriteLine(p[1].exit[5]);
                f.WriteLine(p[17].exit[0]);
                f.WriteLine(p[10].exit[4]);
                f.WriteLine(p[15].exit[2]);
                f.WriteLine(p[26].exit[0]);
                f.WriteLine(cp);
                f.WriteLine(wearingSCUBA);
                f.WriteLine(oiledGate);
                f.Flush();
                f.Close();
            }
        }

        internal void LoadGame()
        {
            if (verb_load()  &&  textBox1.Visibility != System.Windows.Visibility.Visible)
            {
                textBox1.Visibility = System.Windows.Visibility.Visible;
                textBox1.Focus();
                if (owner != null)
                    owner.EnableSaveGameMenuItem(true);
            }
            show_room();
            InvalidateVisual();
        }

        private bool verb_load()
        {
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.DefaultExt = ".sav";
            dlg.Filter = "Save files (.sav)|*.sav";
            bool? result = dlg.ShowDialog();
            if (result != null && result == true)
            {
                string filename = dlg.FileName;
                StreamReader fs;
                try
                {
                    fs = new StreamReader(filename);
                }
                catch (Exception ex)
                {
                    szActionDescription += "Could not open \"" + filename + "\":\n" + ex.Message + "\n";
                    return false;
                }

                try
                {
                    string s;
                    for (int i = 0; i < ob.Length; ++i)
                    {
                        s = fs.ReadLine();
                        ob[i].room = int.Parse (s);
                    }
                    s = fs.ReadLine();
                    p[2].exit[3] = int.Parse (s);
                    s = fs.ReadLine();
                    p[2].exit[2] = int.Parse(s);
                    s = fs.ReadLine();
                    p[1].exit[5] = int.Parse(s);
                    s = fs.ReadLine();
                    p[17].exit[0] = int.Parse(s);
                    s = fs.ReadLine();
                    p[10].exit[4] = int.Parse(s);
                    s = fs.ReadLine();
                    p[15].exit[2] = int.Parse(s);
                    s = fs.ReadLine();
                    p[26].exit[0] = int.Parse(s);
                    s = fs.ReadLine();
                    cp = int.Parse(s);
                    s = fs.ReadLine();
                    wearingSCUBA = bool.Parse(s);
                    s = fs.ReadLine();
                    oiledGate = bool.Parse(s);
                    fs.Close();
                    return true;
                }
                catch (Exception ex)
                {
                    szActionDescription += "Error reading \"" + filename + "\":\n" + ex.Message + "\n";
                    // The game is now in a hopelessly mangled state.  Better give up.
                    adventure_over();
                }
            }
            return false;
        }

        private void verb_quit()
        {
            szActionDescription += "Coward!\n";
            show_score();
            szActionDescription += "and didn't have TIME to win!\n\n";
            adventure_over();
        }

        private void show_score()
        {
            int treasuresStored = 0;
            if (ob[13].room == 6)
                ++ treasuresStored;
            if (ob[16].room == 6)
                ++treasuresStored;
            if (ob[19].room == 6)
                ++treasuresStored;
            if (ob[20].room == 6)
                ++treasuresStored;
            if (ob[24].room == 6)
                ++treasuresStored;
            if (ob[28].room == 6)
                ++treasuresStored;
            szActionDescription += "You scored " + treasuresStored +
                " out of a possible 6 treasures,\n";
        }

        private void lose()
        {
            show_score();
            szActionDescription += "and have * L O S T ! ! *\n\n";
            adventure_over();
        }

        private void adventure_over()
        {
            textBox1.Visibility = System.Windows.Visibility.Hidden;
            if (owner != null)
                owner.EnableSaveGameMenuItem(false);
        }
    }
}
